package rocks.zipcode.io.quiz4.fundamentals;

import com.sun.deploy.util.ArrayUtil;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;

/**
 * @author leon on 11/12/2018.
 */
public class StringEvaluator {
    public static String[] getAllPrefixes(String string) {
        HashSet<String> set = new HashSet<>();
        for (int i = 0; i < string.length(); i++) {
            for (int j = i+1; j <=string.length() ; j++) {
                set.add(string.substring(i,j));
            }

        }
        return set.toArray(new String[0]);
    }

    public static String[] getCommonPrefixes(String string1, String string2) {
        String[] first = getAllPrefixes(string1);
        String[] second = getAllPrefixes(string2);

        HashSet<String> set = new HashSet<>();
        for(String str1:first){
            for(String str2:second){
                if(str1.equals(str2)){
                    set.add(str1);
                }
            }
        }

        return set.toArray(new String[0]);
    }

    public static String getLargestCommonPrefix(String string1, String string2) {
        String[] both = getCommonPrefixes(string1, string2);

        String largest = both[0];

        for(String str:both){
            if(str.length()>largest.length()){
                largest = str;
            }
        }

        return largest;
    }
}
