package rocks.zipcode.io.quiz4.generics;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author leon on 18/12/2018.
 */
public class Group<SomeType> implements GroupInterface<SomeType>, Iterable<SomeType>{
    ArrayList<SomeType> list;

    public Group() {

//        throw new UnsupportedOperationException("Method not yet implemented");
        this.list = new ArrayList<>();
    }

    public Integer count() {
        return list.size();
    }

    public void insert(SomeType value) {
        list.add(value);
    }

    public Boolean has(SomeType value) {
        return list.contains(value);
    }

    public SomeType fetch(int indexOfValue) {
        SomeType result = null;
        for (int i = 0; i < list.size(); i++) {
            if(i == indexOfValue){
                result = list.get(i);
            }
        }
        return result;
    }

    public void delete(SomeType value) {
        for (int i = 0; i < list.size(); i++) {
            if(list.get(i).equals(value)){
                list.remove(i);
            }
        }
    }

    public void clear() {
        list = new ArrayList<>();
    }

    public Iterator<SomeType> iterator() {
        return list.iterator();
    }
}
