package rocks.zipcode.io.quiz4.objectorientation;

/**
 * @author leon on 11/12/2018.
 */
public class StringAssembler {
    private  Character delimeter;
    private StringBuilder builder;

    public StringAssembler(Character delimeter) {

        this.delimeter = delimeter;
        this.builder = new StringBuilder();
    }

    public StringAssembler append(String str) {
        this.builder.append(str).append(this.delimeter);
        return this;
    }

    public String assemble() {
        return this.builder.deleteCharAt(this.builder.length()-1).toString();
    }
}
