package rocks.zipcode.io.quiz4.collections;

import rocks.zipcode.io.quiz4.generics.Group;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author leon on 11/12/2018.
 */
public class SimpleStringGroup extends Group{
    ArrayList<String> stringGroup;

    public SimpleStringGroup() {

//        throw new UnsupportedOperationException("Method not yet implemented");
        this.stringGroup = new ArrayList<>();
    }

    public Integer count() {

        return stringGroup.size();
    }

    public void insert(String string) {
        stringGroup.add(string);
    }

    public Boolean has(String valueToInsert) {
        return stringGroup.contains(valueToInsert);
    }

    public String fetch(int indexOfValue) {
        if(indexOfValue>stringGroup.size()){
            throw new IndexOutOfBoundsException();
        }
        String result = "";
        for (int i = 0; i < stringGroup.size(); i++) {
            if(i==indexOfValue){
                result = stringGroup.get(i);
            }
        }
        return result;
    }

    public void delete(String valueToInsert) {
        for (int i = 0; i < stringGroup.size(); i++) {
            if(stringGroup.get(i).equals(valueToInsert)){
                stringGroup.remove(valueToInsert);
            }
        }
    }

    public void clear() {
        stringGroup = new ArrayList<>();
    }

    public Iterator<String> iterator() {
        return stringGroup.iterator();
    }
}
