package rocks.zipcode.io.quiz4.generics;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * @author leon on 18/12/2018.
 */
public class SortedGroup<SomeType> extends Group<SomeType> implements GroupInterface<SomeType>{
    List<SomeType> list;

    public SortedGroup() {
        this.list = new ArrayList<>();
    }

    @Override
    public void insert(SomeType value) {
        list.add(value);
    }

    @Override
    public void delete(SomeType value) {
        list.remove(value);
    }

    public Integer indexOf(SomeType firstValue) {
        Integer index = 0;
        for (int i = 0; i < list.size(); i++) {
            if(list.get(i).equals(firstValue)){
                index = i;
            }
        }
        return index;
    }
}
