package rocks.zipcode.io.quiz4.objectorientation;

import java.util.ArrayList;
import java.util.HashSet;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeObject {
    private String input;

    public PalindromeObject(String input) {
        this.input = input;
    }

    public String[] getAllPalindromes(){
        ArrayList<String> list = new ArrayList<>();
        for (int i = 0; i <input.length() ; i++) {
            for (int j = i+1; j < input.length()-1; j++) {
                list.add(input.substring(i,j));
            }
        }
        HashSet<String> set = new HashSet<>();
        for(String str:list){
            if(this.isPalindrome()){
                set.add(str);
            }
        }
        return set.toArray(new String[0]);
    }

    public Boolean isPalindrome(){

        return input.equalsIgnoreCase(reverseString());
    }

    public String reverseString(){
        StringBuilder builder = new StringBuilder(input);
        return builder.reverse().toString();
    }
}
