package rocks.zipcode.io.quiz4.objectorientation;

import java.util.HashSet;

/**
 * @author leon on 19/12/2018.
 */
public class StringEvaluatorObject {
    private String str;

    public StringEvaluatorObject(String str) {
        this.str = str;
    }

    public String[] getAllPrefixes() {
        HashSet<String> set = new HashSet<>();
        for (int i = 0; i < str.length(); i++) {
            for (int j = i+1; j <=str.length() ; j++) {
                set.add(str.substring(i,j));
            }

        }
        return set.toArray(new String[0]);
    }

    public String[] getCommonPrefixes(String secondInput) {
        String[] first = this.getAllPrefixes();
        String[] second = new StringEvaluatorObject(secondInput).getAllPrefixes();

        HashSet<String> set = new HashSet<>();
        for(String str1:first){
            for(String str2:second){
                if(str1.equals(str2)){
                    set.add(str1);
                }
            }
        }

        return set.toArray(new String[0]);
    }

    public String getLargestCommonPrefix(String secondInput) {
        String[] both = getCommonPrefixes(secondInput);

        String largest = both[0];

        for(String str:both){
            if(str.length()>largest.length()){
                largest = str;
            }
        }

        return largest;
    }
}
